%define bname           geronimo
%define name            geronimo-specs
%define version         1.0
%define mstone		M2
%define release         0.%{mstone}.3jpp
%define section         free

Summary:        Geronimo J2EE server J2EE specifications
URL:            http://geronimo.apache.org
Source0:        %{bname}-%{version}-%{mstone}-src.tar.gz
Source1:        %{name}-pom-maven2jpp-depcat.xsl
Source2:        %{name}-pom-maven2jpp-newdepmap.xsl
Source3:        %{name}-pom-maven2jpp-mapdeps.xsl
Source4:        geronimo-specs-1.0-M2-jpp-depmap.xml
Patch0:         geronimo-specs-1.0-M2-SchemaCompiler.patch
Patch1:         geronimo-specs-1.0-M2-SchemaConversionUtilsTest.patch
Patch2:         geronimo-specs-1.0-M2-jpp.patch

Name:           %{name}
Version:        %{version}
Release:        %{release}
Epoch:          0
License:        Apache Software License 2
Group:          Development/Libraries/Java
Vendor:         JPackage Project
Distribution:   JPackage
BuildArch:      noarch
BuildRequires:  jpackage-utils >= 0:1.5
BuildRequires:  maven >= 0:1.0
BuildRequires:  isorelax
BuildRequires:  junit >= 0:3.8.1
BuildRequires:  saxon-scripts
BuildRequires:	mockobjects >= 0:0.09
BuildRequires:	mockobjects-jdk1.4 >= 0:0.09
BuildRequires:	mockobjects-jdk1.4-j2ee1.3 >= 0:0.09
BuildRequires:  mx4j >= 0:2.0.1
BuildRequires:  xmlbeans 
BuildRequires:  xml-commons-resolver
#
Requires:  mx4j >= 0:2.0.1
Requires:  xmlbeans 
Requires:  xml-commons-resolver
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
Geronimo is Apache's ASF-licenced J2EE server project.
These are the J2EE-Specifications

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
Javadoc for %{name}.

%prep
%setup -q -n geronimo-%{version}-%{mstone}
chmod -R go=u-w *
mkdir mod_tmp
mv modules/maven-xmlbeans-plugin mod_tmp
rm -rf modules
mv mod_tmp modules
rm -rf applications
rm -rf sandbox

export DEPCAT=$(pwd)/geronimo-specs-1.0-M2-depcat.new.xml
echo '<?xml version="1.0" standalone="yes"?>' > $DEPCAT
echo '<depset>' >> $DEPCAT
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    /usr/bin/saxon project.xml %{SOURCE1} >> $DEPCAT
    popd
done
echo >> $DEPCAT
echo '</depset>' >> $DEPCAT
/usr/bin/saxon $DEPCAT %{SOURCE2} > geronimo-specs-1.0-M2-depmap.new.xml
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    cp project.xml project.xml.orig
    /usr/bin/saxon -o project.xml project.xml.orig %{SOURCE3} map=%{SOURCE4}
    popd
done

for p in $(find . -name project.properties); do
    echo >> $p
    echo maven.repo.remote=file:/usr/share/maven-1.0/repository >> $p
    echo maven.home.local=$(pwd)/.maven >> $p
done

%patch0 -b .sav
%patch1 -b .sav
%patch2 -b .sav

%build
[ -z "$JAVA_HOME" ] && JAVA_HOME=%{_jvmdir}/java
export JAVA_HOME

mkdir -p .maven/repository/JPP/jars
pushd .maven/repository/JPP/jars
ln -sf $(build-classpath xmlbeans/xbean) xmlbeans-xbean.jar
ln -sf $(build-classpath xml-commons-resolver) xml-commons-resolver.jar
ln -sf $(build-classpath mockobjects) mockobjects.jar
ln -sf $(build-classpath mockobjects-core) mockobjects-core.jar
ln -sf $(build-classpath mockobjects-j2ee1.3) mockobjects-jdk1.4-j2ee1.3.jar
ln -sf $(build-classpath mx4j/mx4j-jmx) mx4j-jmx.jar
ln -sf $(build-classpath junit) junit.jar
popd

mkdir -p .maven/repository/maven/jars
pushd .maven/repository/maven/jars
ln -sf $(build-classpath maven-jelly-tags) maven-jelly-tags.jar
popd

export MAVEN_HOME_LOCAL=$(pwd)/.maven
#maven -Dmodule.types=specs,modules modules:build modules:javadoc
maven -Dmodule.types=specs,modules \
      -Dmaven.repo.remote=file:/usr/share/maven-1.0/repository \
      -Dmaven.home.local=$(pwd)/.maven \
      modules:build modules:javadoc

%install
rm -rf $RPM_BUILD_ROOT

# jar
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}/geronimo

install -p -m 0644 specs/ejb/target/geronimo-spec-ejb-2.1-rc2.jar \
	      $RPM_BUILD_ROOT%{_javadir}/geronimo/spec-ejb-2.1-rc2.jar
pushd $RPM_BUILD_ROOT%{_javadir}/geronimo
  ln -sf spec-ejb-2.1-rc2.jar spec-ejb-2.1.jar
popd
install -p -m 0644 specs/j2ee-connector/target/geronimo-spec-j2ee-connector-1.5-rc2.jar \
	      $RPM_BUILD_ROOT%{_javadir}/geronimo/spec-j2ee-connector-1.5-rc2.jar
pushd $RPM_BUILD_ROOT%{_javadir}/geronimo
  ln -sf spec-j2ee-connector-1.5-rc2.jar spec-j2ee-connector-1.5.jar
popd
install -p -m 0644 specs/j2ee-deployment/target/geronimo-spec-j2ee-deployment-1.1-rc2.jar \
	      $RPM_BUILD_ROOT%{_javadir}/geronimo/spec-j2ee-deployment-1.1-rc2.jar
pushd $RPM_BUILD_ROOT%{_javadir}/geronimo
  ln -sf spec-j2ee-deployment-1.1-rc2.jar spec-j2ee-deployment-1.1.jar
popd
install -p -m 0644 specs/j2ee-jacc/target/geronimo-spec-j2ee-jacc-1.0-rc2.jar \
	      $RPM_BUILD_ROOT%{_javadir}/geronimo/spec-j2ee-jacc-1.0-rc2.jar
pushd $RPM_BUILD_ROOT%{_javadir}/geronimo
  ln -sf spec-j2ee-jacc-1.0-rc2.jar spec-j2ee-jacc-1.0.jar
popd
install -p -m 0644 specs/j2ee-management/target/geronimo-spec-j2ee-management-1.0-rc2.jar \
	      $RPM_BUILD_ROOT%{_javadir}/geronimo/spec-j2ee-management-1.0-rc2.jar
pushd $RPM_BUILD_ROOT%{_javadir}/geronimo
  ln -sf spec-j2ee-management-1.0-rc2.jar spec-j2ee-management-1.0.jar
popd
install -p -m 0644 specs/j2ee/target/geronimo-spec-j2ee-1.4-rc2.jar \
	      $RPM_BUILD_ROOT%{_javadir}/geronimo/spec-j2ee-1.4-rc2.jar
pushd $RPM_BUILD_ROOT%{_javadir}/geronimo
  ln -sf spec-j2ee-1.4-rc2.jar spec-j2ee-1.4.jar
popd
install -p -m 0644 specs/jms/target/geronimo-spec-jms-1.1-rc2.jar \
	      $RPM_BUILD_ROOT%{_javadir}/geronimo/spec-jms-1.1-rc2.jar
pushd $RPM_BUILD_ROOT%{_javadir}/geronimo
  ln -sf spec-jms-1.1-rc2.jar spec-jms-1.1.jar
popd
install -p -m 0644 specs/jsp/target/geronimo-spec-jsp-2.0-rc2.jar \
	      $RPM_BUILD_ROOT%{_javadir}/geronimo/spec-jsp-2.0-rc2.jar
pushd $RPM_BUILD_ROOT%{_javadir}/geronimo
  ln -sf spec-jsp-2.0-rc2.jar spec-jsp-2.0.jar
popd
install -p -m 0644 specs/jta/target/geronimo-spec-jta-1.0.1B-rc2.jar \
	      $RPM_BUILD_ROOT%{_javadir}/geronimo/spec-jta-1.0.1B-rc2.jar
pushd $RPM_BUILD_ROOT%{_javadir}/geronimo
  ln -sf spec-jta-1.0.1B-rc2.jar spec-jta-1.0.1B.jar
popd
install -p -m 0644 specs/schema/target/geronimo-spec-j2eeschema-1.0-M2.jar \
	      $RPM_BUILD_ROOT%{_javadir}/geronimo/spec-j2eeschema-1.0-M2.jar
pushd $RPM_BUILD_ROOT%{_javadir}/geronimo
  ln -sf spec-j2eeschema-1.0-M2.jar spec-j2eeschema-1.0.jar
popd
install -p -m 0644 specs/servlet/target/geronimo-spec-servlet-2.4-rc2.jar \
	      $RPM_BUILD_ROOT%{_javadir}/geronimo/spec-servlet-2.4-rc2.jar
pushd $RPM_BUILD_ROOT%{_javadir}/geronimo
  ln -sf spec-servlet-2.4-rc2.jar spec-servlet-2.4.jar
popd


# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
for sp in ejb j2ee-connector j2ee-deployment j2ee-jacc j2ee-management jms jsp jta servlet; do
    install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/${sp}
    cp -pr specs/${sp}/target/docs/apidocs/* \
         $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/${sp}
done
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -sf %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(-,root,root,-)
%doc LICENSE.txt
%{_javadir}/*

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%changelog
* Thu Jun 01 2005 Fernando Nasser <fnasser@redhat.com> 0:1.0-0.M2.3jpp
- Add missing dependency on isorelax
- Set JAVA_HOME
- Rename pom files to prevent conflict with similar files from other packages

* Thu Feb 03 2005 Ralph Apel <r.apel at r-apel.de> 0:1.0-0.M2.2jpp
- Process project.xml files with saxon
- Don't tamper with $HOME
- Don't use build-jar-repository: [xyz].jar will not work with geronimo deploy

* Fri Oct 08 2004 Ralph Apel <r.apel at r-apel.de> 0:1.0-0.M2.1jpp
- Upgrade to M2
* Thu Sep 30 2004 Ralph Apel <r.apel at r-apel.de> 0:1.0-0.M1.1jpp
- First JPackage build

